/* util-gfx.c generated by valac 0.43.6, the Vala compiler
 * generated from util-gfx.vala, do not modify */

/* Copyright 2014-2015 Yorba Foundation
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <float.h>
#include <math.h>

void california_gfx_rgb_string_to_rgba (const gchar* rgb_string,
                                        GdkRGBA* default_rgba,
                                        gboolean* used_default,
                                        GdkRGBA* result);
gboolean california_string_is_empty (const gchar* str);
guint32 california_gfx_rgba_to_pixel (GdkRGBA* rgba);
guint8 california_gfx_fp_to_uint8 (gdouble value);
gchar* california_gfx_rgba_to_uint8_rgb_string (GdkRGBA* rgba);

const GdkRGBA CALIFORNIA_GFX_BLACK = {0.0, 0.0, 0.0, 1.0};
const GdkRGBA CALIFORNIA_GFX_WHITE = {1.0, 1.0, 1.0, 1.0};

/**
 * Convert an RGBA string into an RGBA structure.
 *
 * The string can be in any of the forms that Gdk.RGBA.parse accepts.  If unable to parse the
 * string, the {@link default_rgba} is returned and {@link used_default} is set to true.
 */
void
california_gfx_rgb_string_to_rgba (const gchar* rgb_string,
                                   GdkRGBA* default_rgba,
                                   gboolean* used_default,
                                   GdkRGBA* result)
{
	gboolean _vala_used_default = FALSE;
	GdkRGBA rgba = {0};
#line 18 "util/util-gfx.vala"
	g_return_if_fail (default_rgba != NULL);
#line 19 "util/util-gfx.vala"
	if (california_string_is_empty (rgb_string)) {
#line 48 "util-gfx.c"
		GdkRGBA _tmp0_;
#line 20 "util/util-gfx.vala"
		_vala_used_default = TRUE;
#line 22 "util/util-gfx.vala"
		_tmp0_ = *default_rgba;
#line 22 "util/util-gfx.vala"
		*result = _tmp0_;
#line 22 "util/util-gfx.vala"
		if (used_default) {
#line 22 "util/util-gfx.vala"
			*used_default = _vala_used_default;
#line 60 "util-gfx.c"
		}
#line 22 "util/util-gfx.vala"
		return;
#line 64 "util-gfx.c"
	}
#line 25 "util/util-gfx.vala"
	memset (&rgba, 0, sizeof (GdkRGBA));
#line 26 "util/util-gfx.vala"
	if (!gdk_rgba_parse (&rgba, rgb_string)) {
#line 70 "util-gfx.c"
		GdkRGBA _tmp1_;
#line 27 "util/util-gfx.vala"
		g_debug ("util-gfx.vala:27: Unable to parse RGBA color \"%s\"", rgb_string);
#line 29 "util/util-gfx.vala"
		_vala_used_default = TRUE;
#line 31 "util/util-gfx.vala"
		_tmp1_ = *default_rgba;
#line 31 "util/util-gfx.vala"
		*result = _tmp1_;
#line 31 "util/util-gfx.vala"
		if (used_default) {
#line 31 "util/util-gfx.vala"
			*used_default = _vala_used_default;
#line 84 "util-gfx.c"
		}
#line 31 "util/util-gfx.vala"
		return;
#line 88 "util-gfx.c"
	}
#line 34 "util/util-gfx.vala"
	_vala_used_default = FALSE;
#line 36 "util/util-gfx.vala"
	*result = rgba;
#line 36 "util/util-gfx.vala"
	if (used_default) {
#line 36 "util/util-gfx.vala"
		*used_default = _vala_used_default;
#line 98 "util-gfx.c"
	}
#line 36 "util/util-gfx.vala"
	return;
#line 102 "util-gfx.c"
}

/**
 * Converts the Gdk.RGBA into a 32-bit pixel representation.
 */
guint32
california_gfx_rgba_to_pixel (GdkRGBA* rgba)
{
	guint32 result = 0U;
	GdkRGBA _tmp0_;
	GdkRGBA _tmp1_;
	GdkRGBA _tmp2_;
	GdkRGBA _tmp3_;
#line 42 "util/util-gfx.vala"
	g_return_val_if_fail (rgba != NULL, 0U);
#line 43 "util/util-gfx.vala"
	_tmp0_ = *rgba;
#line 43 "util/util-gfx.vala"
	_tmp1_ = *rgba;
#line 43 "util/util-gfx.vala"
	_tmp2_ = *rgba;
#line 43 "util/util-gfx.vala"
	_tmp3_ = *rgba;
#line 43 "util/util-gfx.vala"
	result = (((((guint32) california_gfx_fp_to_uint8 (_tmp0_.red)) << 24) | (((guint32) california_gfx_fp_to_uint8 (_tmp1_.green)) << 16)) | (((guint32) california_gfx_fp_to_uint8 (_tmp2_.blue)) << 8)) | ((guint32) california_gfx_fp_to_uint8 (_tmp3_.alpha));
#line 43 "util/util-gfx.vala"
	return result;
#line 130 "util-gfx.c"
}

inline guint8
california_gfx_fp_to_uint8 (gdouble value)
{
	guint8 result = 0U;
#line 50 "util/util-gfx.vala"
	result = (guint8) round (value * ((gdouble) G_MAXUINT8));
#line 50 "util/util-gfx.vala"
	return result;
#line 141 "util-gfx.c"
}

/**
 * Converts the Gdk.RGBA into an RGB string representation ("#ad12c3")
 *
 * Note that alpha channel information is lost in this conversion.
 */
gchar*
california_gfx_rgba_to_uint8_rgb_string (GdkRGBA* rgba)
{
	gchar* result = NULL;
	GdkRGBA _tmp0_;
	GdkRGBA _tmp1_;
	GdkRGBA _tmp2_;
	gchar* _tmp3_;
#line 58 "util/util-gfx.vala"
	g_return_val_if_fail (rgba != NULL, NULL);
#line 59 "util/util-gfx.vala"
	_tmp0_ = *rgba;
#line 59 "util/util-gfx.vala"
	_tmp1_ = *rgba;
#line 59 "util/util-gfx.vala"
	_tmp2_ = *rgba;
#line 59 "util/util-gfx.vala"
	_tmp3_ = g_strdup_printf ("#%02x%02x%02x", (guint) california_gfx_fp_to_uint8 (_tmp0_.red), (guint) california_gfx_fp_to_uint8 (_tmp1_.green), (guint) california_gfx_fp_to_uint8 (_tmp2_.blue));
#line 59 "util/util-gfx.vala"
	result = _tmp3_;
#line 59 "util/util-gfx.vala"
	return result;
#line 171 "util-gfx.c"
}

